



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SharedPreferences最佳实践</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SharedPreferences最佳实践</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-23 08:44:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转：http://blog.csdn.net/xushuaic/article/details/24513599</p>
<p><strong>笔记摘要：</strong>该文章是我在Android Weekly中看到的，以前也一直用SharedPreferences，不过一直只是会用，并没有深入研究下，既然看过了这篇文章，就翻下记录下来对自己理解也会有帮助，和朋友们分享下。另外提一下<a href="http://androidweekly.net/" rel="external nofollow noreferrer">Android Weekly</a>，这是一个每周发布一次Android行业最新动态的国外网站，其中的LatestIssue和ToolBox模块你可以关注下，LatestIssue会发布一下比较优秀的新的开源项目，每周我都会看一下，之后一定就在gitHub上找到并start上了。ToolBox模块就是一些好的开源项目了，不过更新的不怎么频繁，大家也可以看下。</p>
<p>先贴上作者发布到GitHub的源代码：<a href="https://github.com/yakivmospan/code-view/blob/gh-pages/articles/android/best%20practice/Best%20Practice.%20SharedPreferences.md" rel="external nofollow noreferrer">Best Practice. SharedPreferences.</a><br />原文地址：<a href="https://github.com/yakivmospan/code-view/blob/gh-pages/articles/android/best%20practice/Best%20Practice.%20SharedPreferences.md" rel="external nofollow noreferrer">Best Practice</a>&nbsp;，以下是译文。</p>
<p>Android开发者有很多方式都可以存储应用的数据。其中之一是SharedPreference对象，该对象可以通过key-value的形式保存私有的数据。</p>
<p><strong>所有的逻辑依赖下面3个类</strong><br />SharedPreferences<br />SharedPreferences.Editor<br />SharedPreferences.OnSharedPreferenceChangeListener</p>
<p><strong>SharedPreferences</strong><br />SharedPreferences在这3个类中是最主要的。它负提供了获取Editor对象的接口和添加删除的监听：OnSharedPreferenceChangeListener</p>
<p>- 创建SharedPreferences 时，你需要Context对象<br />- getSharedPreferences方法用于解析Preference文件并为其创建Map对象。<br />- 你可以通过提供的Context创建不同的模式，强烈建议使用MODE_PRIVATE，因为创建任意可读取的文件是非常危险的，可能会在应用中导致一些安全问题。</p>
<div>
<ol><li>//&nbsp;parse&nbsp;Preference&nbsp;file</li>
<li>SharedPreferences&nbsp;preferences&nbsp;=&nbsp;context.getSharedPreferences("com.example.app",&nbsp;Context.MODE_PRIVATE);</li>
<li>//&nbsp;get&nbsp;values&nbsp;from&nbsp;Map</li>
<li>preferences.getBoolean("key",&nbsp;defaultValue)</li>
<li>preferences.get..("key",&nbsp;defaultValue)</li>
<li>//&nbsp;you&nbsp;can&nbsp;get&nbsp;all&nbsp;Map&nbsp;but&nbsp;be&nbsp;careful&nbsp;you&nbsp;must&nbsp;not&nbsp;modify&nbsp;the&nbsp;collection&nbsp;returned&nbsp;by&nbsp;this</li>
<li>//&nbsp;method,&nbsp;or&nbsp;alter&nbsp;any&nbsp;of&nbsp;its&nbsp;contents.</li>
<li>Map&lt;String,&nbsp;?&gt;&nbsp;all&nbsp;=&nbsp;preferences.getAll();</li>
<li>//&nbsp;get&nbsp;Editor&nbsp;object</li>
<li>SharedPreferences.Editor&nbsp;editor&nbsp;=&nbsp;preferences.edit();</li>
<li>//add&nbsp;on&nbsp;Change&nbsp;Listener</li>
<li>preferences.registerOnSharedPreferenceChangeListener(mListener);</li>
<li>//remove&nbsp;on&nbsp;Change&nbsp;Listener</li>
<li>preferences.unregisterOnSharedPreferenceChangeListener(mListener);</li>
<li>//&nbsp;listener&nbsp;example</li>
<li>SharedPreferences.OnSharedPreferenceChangeListener&nbsp;mOnSharedPreferenceChangeListener</li>
<li>=&nbsp;new&nbsp;SharedPreferences.OnSharedPreferenceChangeListener()&nbsp;{</li>
<li>@Override</li>
<li>public&nbsp;void&nbsp;onSharedPreferenceChanged(SharedPreferences&nbsp;sharedPreferences,&nbsp;String&nbsp;key)&nbsp;{</li>
<li>}</li>
<li>};</li></ol>
</div>
<p><strong>Editor</strong><br />SharedPreference.Editor 是一个用于修改SharedPreferences值的接口。在Editor里所做的所有变更都会被批处理，但是不会立即覆盖到原始的SharedPreferences中，直到你调用了commit()或者apply()。</p>
<p>- 使用简单的接口保存值到Editor中<br />- 使用commit()同步或者apply()异步保存值（异步更快）。事实上，在不同的线程中使用commit()更安全，这也正是我倾向于使用commit()的原因。<br />- 通过remove()移除单一的值或者通过clear删除所有的值。</p>
<div>
<ol><li>//&nbsp;get&nbsp;Editor&nbsp;object</li>
<li>SharedPreferences.Editor&nbsp;editor&nbsp;=&nbsp;preferences.edit();</li>
<li>//&nbsp;put&nbsp;values&nbsp;in&nbsp;editor</li>
<li>editor.putBoolean("key",&nbsp;value);</li>
<li>editor.put..("key",&nbsp;value);</li>
<li>//&nbsp;remove&nbsp;single&nbsp;value&nbsp;by&nbsp;key</li>
<li>editor.remove("key");</li>
<li>//&nbsp;remove&nbsp;all&nbsp;values</li>
<li>editor.clear();</li>
<li>//&nbsp;commit&nbsp;your&nbsp;putted&nbsp;values&nbsp;to&nbsp;the&nbsp;SharedPreferences&nbsp;object&nbsp;synchronously</li>
<li>//&nbsp;returns&nbsp;true&nbsp;if&nbsp;success</li>
<li>boolean&nbsp;result&nbsp;=&nbsp;editor.commit();</li>
<li>//&nbsp;do&nbsp;the&nbsp;same&nbsp;as&nbsp;commit()&nbsp;but&nbsp;asynchronously&nbsp;(faster&nbsp;but&nbsp;not&nbsp;safely)</li>
<li>//&nbsp;returns&nbsp;nothing</li>
<li>editor.apply();</li></ol>
</div>
<p><strong>性能和贴士</strong><br />SharedPreferences 是一个单例对象，因此，你可以在很多地方引用它，获取也很容易。它只会在第一次调用getSharedPreferences的时候打开或者为其创建一个引用。</p>
<div>
<ol><li>//&nbsp;There&nbsp;are&nbsp;1000&nbsp;String&nbsp;values&nbsp;in&nbsp;preferences</li>
<li>SharedPreferences&nbsp;first&nbsp;=&nbsp;context.getSharedPreferences("com.example.app",&nbsp;Context.MODE_PRIVATE);</li>
<li>//&nbsp;call&nbsp;time&nbsp;=&nbsp;4&nbsp;milliseconds</li>
<li>SharedPreferences&nbsp;second&nbsp;=&nbsp;context.getSharedPreferences("com.example.app",&nbsp;Context.MODE_PRIVATE);</li>
<li>//&nbsp;call&nbsp;time&nbsp;=&nbsp;0&nbsp;milliseconds</li>
<li>SharedPreferences&nbsp;third&nbsp;=&nbsp;context.getSharedPreferences("com.example.app",&nbsp;Context.MODE_PRIVATE);</li>
<li>//&nbsp;call&nbsp;time&nbsp;=&nbsp;0&nbsp;milliseconds</li></ol>
</div>
<p>由于SharedPreferences是一个单例对象，你不用担心任意的变更会导致数据的不一致。</p>
<div>
<ol><li>first.edit().putInt("key",15).commit();</li>
<li>int&nbsp;firstValue&nbsp;=&nbsp;first.getInt("key",0));&nbsp;//&nbsp;firstValue&nbsp;is&nbsp;15</li>
<li>int&nbsp;secondValue&nbsp;=&nbsp;second.getInt("key",0));&nbsp;//&nbsp;secondValue&nbsp;is&nbsp;also&nbsp;15</li></ol>
</div>
<p>当你第一次调用get方法的时候，它会通过key解析值，并把这些值添加到map集合中。因此对于下面的second调用它，只会从map中获取，而不再解析。</p>
<div>
<ol><li>first.getString("key",&nbsp;null)</li>
<li>//&nbsp;call&nbsp;time&nbsp;=&nbsp;147&nbsp;milliseconds</li>
<li>first.getString("key",&nbsp;null)</li>
<li>//&nbsp;call&nbsp;time&nbsp;=&nbsp;0&nbsp;milliseconds</li>
<li>second.getString("key",&nbsp;null)</li>
<li>//&nbsp;call&nbsp;time&nbsp;=&nbsp;0&nbsp;milliseconds</li>
<li>third.getString("key",&nbsp;null)</li>
<li>//&nbsp;call&nbsp;time&nbsp;=&nbsp;0&nbsp;milliseconds</li></ol>
</div>
<p>记住Preference对象越大，对于get,commit,apply和clear的操作时间将会越长。因此强烈建议在不同的小对象中分开操作你的数据。<br />你的preference在应用更新的时候不会被移除。因此，这时候，你需要创建一些新的升级规则。比如你有一个应用，它会在启动的时候解析本地的JSON数据，在你第一次启动后，你决定保存wasLocalDataLoaded 标记。在之后的多次更新JSON数据和发布新版本的时候，用户只会更新它们的应用而不会再加载新的JSON数据，因为它们已经在第一个版本中加载过了。</p>
<div>
<ol><li>public&nbsp;class&nbsp;MigrationManager&nbsp;{</li>
<li>private&nbsp;final&nbsp;static&nbsp;String&nbsp;KEY_PREFERENCES_VERSION&nbsp;=&nbsp;"key_preferences_version";</li>
<li>private&nbsp;final&nbsp;static&nbsp;int&nbsp;PREFERENCES_VERSION&nbsp;=&nbsp;2;</li>
<li>public&nbsp;static&nbsp;void&nbsp;migrate(Context&nbsp;context)&nbsp;{</li>
<li>SharedPreferences&nbsp;preferences&nbsp;=&nbsp;context.getSharedPreferences("pref",&nbsp;Context.MODE_PRIVATE);</li>
<li>checkPreferences(preferences);</li>
<li>}</li>
<li>private&nbsp;static&nbsp;void&nbsp;checkPreferences(SharedPreferences&nbsp;thePreferences)&nbsp;{</li>
<li>final&nbsp;double&nbsp;oldVersion&nbsp;=&nbsp;thePreferences.getInt(KEY_PREFERENCES_VERSION,&nbsp;1);</li>
<li>if&nbsp;(oldVersion&nbsp;&lt;&nbsp;PREFERENCES_VERSION)&nbsp;{</li>
<li>final&nbsp;SharedPreferences.Editor&nbsp;edit&nbsp;=&nbsp;thePreferences.edit();</li>
<li>edit.clear();</li>
<li>edit.putInt(KEY_PREFERENCES_VERSION,&nbsp;currentVersion);</li>
<li>edit.commit();</li>
<li>}</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>SharedPreferences 是以XML的格式保存在你的data文件夹中的</p>
<div>
<ol><li>//&nbsp;yours&nbsp;preferences</li>
<li>/data/data/YOUR_PACKAGE_NAME/shared_prefs/YOUR_PREFS_NAME.xml</li>
<li>//&nbsp;default&nbsp;preferences</li>
<li>/data/data/YOUR_PACKAGE_NAME/shared_prefs/YOUR_PACKAGE_NAME_preferences.xml</li></ol>
</div>
<p><strong>示例代码</strong></p>
<div>
<ol><ol><li>public&nbsp;class&nbsp;PreferencesManager&nbsp;{</li>
<li>private&nbsp;static&nbsp;final&nbsp;String&nbsp;PREF_NAME&nbsp;=&nbsp;"com.example.app.PREF_NAME";</li>
<li>private&nbsp;static&nbsp;final&nbsp;String&nbsp;KEY_VALUE&nbsp;=&nbsp;"com.example.app.KEY_VALUE";</li>
<li>private&nbsp;static&nbsp;PreferencesManager&nbsp;sInstance;</li>
<li>private&nbsp;final&nbsp;SharedPreferences&nbsp;mPref;</li>
<li>private&nbsp;PreferencesManager(Context&nbsp;context)&nbsp;{</li>
<li>mPref&nbsp;=&nbsp;context.getSharedPreferences(PREF_NAME,&nbsp;Context.MODE_PRIVATE);</li>
<li>}</li>
<li>public&nbsp;static&nbsp;synchronized&nbsp;void&nbsp;initializeInstance(Context&nbsp;context)&nbsp;{</li>
<li>if&nbsp;(sInstance&nbsp;==&nbsp;null)&nbsp;{</li>
<li>sInstance&nbsp;=&nbsp;new&nbsp;PreferencesManager(context);</li>
<li>}</li>
<li>}</li>
<li>public&nbsp;static&nbsp;synchronized&nbsp;PreferencesManager&nbsp;getInstance()&nbsp;{</li>
<li>if&nbsp;(sInstance&nbsp;==&nbsp;null)&nbsp;{</li>
<li>throw&nbsp;new&nbsp;IllegalStateException(PreferencesManager.class.getSimpleName()&nbsp;+</li>
<li>"&nbsp;is&nbsp;not&nbsp;initialized,&nbsp;call&nbsp;initializeInstance(..)&nbsp;method&nbsp;first.");</li>
<li>}</li>
<li>return&nbsp;sInstance;</li>
<li>}</li>
<li>public&nbsp;void&nbsp;setValue(long&nbsp;value)&nbsp;{</li>
<li>mPref.edit()</li>
<li>.putLong(KEY_VALUE,&nbsp;value)</li>
<li>.commit();</li>
<li>}</li>
<li>public&nbsp;long&nbsp;getValue()&nbsp;{</li>
<li>return&nbsp;mPref.getLong(KEY_VALUE,&nbsp;0);</li>
<li>}</li>
<li>public&nbsp;void&nbsp;remove(String&nbsp;key)&nbsp;{</li>
<li>mPref.edit()</li>
<li>.remove(key)</li>
<li>.commit();</li>
<li>}</li>
<li>public&nbsp;boolean&nbsp;clear()&nbsp;{</li>
<li>return&nbsp;mPref.edit()</li>
<li>.clear()</li>
<li>.commit();</li>
<li>}</li></ol></ol>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pgj779.html">ZYNQ学习之&mdash;&mdash;MIO</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnw6vxq.html">嵌套移动APP端的H5页面meta标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2nw2oq.html">Bootstrap学习------Tabel</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw16g38.html">iOS 刚刚，几分钟前，几小时前，几天前，几月前，几年前</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxp0ev9.html">WAF绕过小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w0dm3q.html">【JavaScript】javascript常用的东西</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1g0rk8.html">CentOS 7学习笔记&lpar;二&rpar;之Nginx安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmd5m19.html">careercup-数组和字符串1&period;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xe4we8.html">KVM virt-manager使用&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv4dzxq.html">python-登录-注册-修改密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv4nmxq.html">sqlplus 一次奇葩问题 HTTP proxy setting has incorrect value</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vwor48.html">IM与工作信息流整合</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjv3n38.html">开发win8 metro monogame，显示pubcenter广告时会使游戏卡住的问题的解决方法。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk2pjz8.html">Java IO 节点流 FileInput&sol;OutputStream</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z42we9.html">从市场运营角度谈Uber中国的第一批用户是怎么来的</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k10k29.html">玩转vue前进刷新，后退不刷新and按需刷新</a>
		</li>
						<li><a href="https://www.batexi.com/a/95ggymmq.html">SQL三表左关联查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwx2n78.html">Eclipse中部署Android开发环境插件安装问题方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwx0lv9.html">Consul内部分享ppt</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2npd19.html">Oracle 导入导出报错的简单处理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2wrkl3q.html">引用枚举进行对比时  enum需强制转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o1mxj9.html">BS常用方法备忘</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdemdjx9.html">HTML&mdash;&mdash;框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok7vg59.html">Ext布局篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvxk4zq.html">bootstrap简章</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1m6419.html">hdu 5755 Gambler Bo  高斯消元</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdok5d8.html">4x4矩阵键盘扫描</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o14jj9.html">未能加载文件 &percnt;CommonDir&percnt;&bsol;dte90a&period;olb。未能找到该文件，因此解决此问题的尝试失败</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1wl569.html">复旦大学EWP菁英女性课程（复旦卓越女性课程改版后第一期） &lowbar;复旦大学、女性课程、高级研修班、心理学、EWP&lowbar;培训通课程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjzy5y9.html">Python学习笔记1-搭建Python环境 和 Python Hello World&excl;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
